/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;

import java.awt.Color;
import java.awt.Graphics2D;
import java.text.DecimalFormat;
import java.text.NumberFormat;

/**
 *
 * @author fotis
 */
public class MaterialBeam extends Material {

    private double E;
    private double nu;

    public MaterialBeam(double gamma, double E, double nu) {
        super(gamma);
        this.E = E;
        this.nu = nu;
    }

    public double getE() {
        return E;
    }

    public double getNu() {
        return nu;
    }

    public void setE(double E) {
        this.E = E;
    }

    public void setNu(double nu) {
        this.nu = nu;
    }

    @Override
    public void draw(Graphics2D g2, int x0, int y0) {
        g2.setColor(Color.BLACK);
        g2.drawLine(x0, y0 - 20, x0 + 200, y0 - 20);
        g2.drawLine(x0, y0 - 70, x0 + 200, y0 - 70);
        g2.drawLine(x0, y0 - 20, x0, y0 - 70);
        g2.drawLine(x0 + 200, y0 - 20, x0 + 200, y0 - 70);
        NumberFormat f=new DecimalFormat("0.00");
        NumberFormat e=new DecimalFormat("#0.0E00");
        g2.drawString("E ", x0+10, y0-55);
        g2.drawString("ν ", x0+10, y0-40);
        g2.drawString("γb", x0+10, y0-25);
        g2.drawString(" = "+e.format(E)+"kN/m2", x0+30, y0-55);
        g2.drawString(" = "+f.format(nu), x0+30, y0-40);
        g2.drawString(" = "+f.format(gamma)+"kN/m3", x0+30, y0-25);
    }
    @Override
    public String toString(){
        String s="\t<concrete>\n";
        s+="\t\t<E>"+E+"</E>\n";
        s+="\t\t<nu>"+nu+"</nu>\n";
        s+="\t\t<gamma>"+gamma+"</gamma>\n";
        s+="\t</concrete>\n";
        return s;
    }            
}