/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;

import java.awt.Color;
import java.awt.Graphics2D;
import java.text.DecimalFormat;
import java.text.NumberFormat;

/**
 *
 * @author fotis
 */
public class MaterialSoil extends Material {

    private double Ks;

    public MaterialSoil(double gamma, double Ks) {
        super(gamma);
        this.Ks = Ks;
    }

    public void setKs(double Ks) {
        this.Ks = Ks;
    }

    public double getKs() {
        return Ks;
    }

    @Override
    public void draw(Graphics2D g2, int x0, int y0) {
        NumberFormat f1=new DecimalFormat("0");
        NumberFormat f2=new DecimalFormat("0.0");
        g2.setColor(Color.BLACK);
        g2.drawLine(x0, y0 - 75, x0 + 200, y0 - 75);
        g2.drawLine(x0, y0 - 115, x0 + 200, y0 - 115);
        g2.drawLine(x0, y0 - 75, x0, y0 - 115);
        g2.drawLine(x0 + 200, y0 - 75, x0 + 200, y0 - 115);
        g2.drawString("Ks ", x0+10, y0-100);
        g2.drawString("γs ", x0+10, y0-85);
        g2.drawString(" = "+f1.format(Ks)+"kN/m3", x0+30, y0-100);
        g2.drawString(" = "+f2.format(gamma)+"kN/m3", x0+30, y0-85);

    }
    @Override
    public String toString(){
        String s="\t<soil>\n";
        s+="\t\t<Ks>"+Ks+"</Ks>\n";
        s+="\t\t<gamma>"+gamma+"</gamma>\n";
        s+="\t</soil>\n";
        return s;
    }        
}
