/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package core;

/**
 *
 * @author fotis
 */
public class Node {

    private int id;
    private double x;
    private int fTable[];
    private double u[];
    private double F[];

    public Node() {
    }

    public Node(int id,double x) {
        this.id = id;
        this.x = x;
        u=new double[2];
        fTable=new int[2];
        fTable[0]=2*(id-1);
        fTable[1]=2*(id-1)+1;
        F=new double[2];
        F[0]=0.;
        F[1]=0.;
    }
    public Node(int id,double x,int fTable[],double F[],double u[]) {
        this.id = id;
        this.x = x;
        this.fTable=fTable;
        this.u=u;
        this.F=F;
    }

    public int getId() {
        return id;
    }

    public double getX() {
        return x;
    }
    public double[] getU() {
        return u;
    }
    public int[] getFTable() {
        return fTable;
    }

    public void setLoad(double V,double M) {
        F[0] = V;
        F[1] = M;
    }

    public double[] getF() {
        return F;
    }
    public void update(double[] X){
        u[0]=X[fTable[0]];
        u[1]=X[fTable[1]];
    }

    public void clear(){
        u[0]=0.;
        u[1]=0.;
    }
    @Override
    public String toString(){
        String s="\t<node>\n";
        s+="\t\t<id>"+id+"</id>\n";
        s+="\t\t<x>"+x+"</x>\n";
        s+="\t\t<u>"+u[0]+" "+u[1]+"</u>\n";
        s+="\t\t<fTable>"+fTable[0]+" "+fTable[1]+"</fTable>\n";
        s+="\t\t<F>"+F[0]+" "+F[1]+"</F>\n"; 
        s+="\t</node>\n";
        return s;
    }
}
