/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;

import java.awt.Color;
import java.awt.Graphics2D;
import java.text.DecimalFormat;
import java.text.NumberFormat;

/**
 *
 * @author fotis
 */
public class SectionRectangle extends Section {

    private double b0;
    private double h0;
    private double h1;
   

    public SectionRectangle(double b,double h,double b0,double h0,double h1) {
        super(b,h);
        tag="RECT";
        
        this.b0 = b0;
        this.h0 = h0;
        this.h1 = h1;
        
        // lower rectangle 
	double A1=b*h0;
	double ys1=0.5*h0;
	double I1=b*h0*h0*h0/12;

        // lower rectangle
	double A2=b0*h1;
	double ys2=h0+0.5*h1;
	double I2=b0*h1*h1*h1/12;

        // area
	A=A1+A2;
        
        // moment of inertia
	double ys=(ys1*A1+ys2*A2)/(A1+A2);
	I=I1+(ys-ys1)*(ys-ys1)*A1+
	  I2+(ys-ys2)*(ys-ys2)*A2;
        
        // soil area
        Au=b*h-A;
    }

    public double getB0() {
        return b0;
    }

    public double getH0() {
        return h0;
    }

    @Override
    public void draw(Graphics2D g2, int x0, int y0) {
        g2.setColor(Color.BLACK);
        g2.drawLine(x0, y0 - 20, x0 + 210, y0 - 20);
        g2.drawLine(x0, y0 - 115, x0 + 210, y0 - 115);
        g2.drawLine(x0, y0 - 20, x0, y0 - 115);
        g2.drawLine(x0 + 210, y0 - 20, x0 + 210, y0 - 115);
        g2.setColor(Color.BLUE);
        g2.drawLine(x0 + 10, y0 - 40, x0 + 85, y0 - 40);
        g2.drawLine(x0 + 10, y0 - 40, x0 + 10, y0 - 65);
        g2.drawLine(x0 + 85, y0 - 40, x0 + 85, y0 - 65);
        g2.drawLine(x0 + 10, y0 - 65, x0 + 35, y0 - 65);
        g2.drawLine(x0 + 85, y0 - 65, x0 + 60, y0 - 65);
        g2.drawLine(x0 + 35, y0 - 65, x0 + 35, y0 - 100);
        g2.drawLine(x0 + 60, y0 - 65, x0 + 60, y0 - 100);
        g2.drawLine(x0 + 35, y0 - 100, x0 + 60, y0 - 100);
        g2.setColor(Color.BLACK);
        NumberFormat f=new DecimalFormat("###0.00");
        g2.drawString("b ", x0+100, y0-100);
        g2.drawString("b0", x0+100, y0-85);
        g2.drawString("h ", x0+100, y0-70);
        g2.drawString("h0", x0+100, y0-55);
        g2.drawString("h1", x0+100, y0-40);
        g2.drawString(" = "+f.format(b)+"m", x0+120, y0-100);
        g2.drawString(" = "+f.format(b0)+"m", x0+120, y0-85);
        g2.drawString(" = "+f.format(h)+"m", x0+120, y0-70);
        g2.drawString(" = "+f.format(h0)+"m", x0+120, y0-55);
        g2.drawString(" = "+f.format(h1)+"m", x0+120, y0-40);
    }
    @Override
    public String toString(){
        String s="\t<section_rect>\n";
        s+="\t\t<b>"+b+"</b>\n";
        s+="\t\t<h>"+h+"</h>\n";
        s+="\t\t<b0>"+b0+"</b0>\n";
        s+="\t\t<h0>"+h0+"</h0>\n";
        s+="\t\t<h1>"+h1+"</h1>\n";
        s+="\t\t<A>"+A+"</A>\n";
        s+="\t\t<I>"+I+"</I>\n";
        s+="\t</section_rect>\n";
        return s;
    }    
}
