/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Line2D;
import java.text.DecimalFormat;
import java.util.Vector;

/**
 *
 * @author fotis
 */
public class DrawPanelOutput extends DrawPanel {
 
    
    public DrawPanelOutput(){
        
    }
  

    private void drawU(Graphics2D g2){
        //setResolutionY(domain.getMaxU());
        Vector<core.Beam> beams=domain.getBeams();
        DecimalFormat f=new DecimalFormat("###.00");
        double x1,x2,y1,y2;
        x1=0.;
        y1=0.;
        for(int i=0;i<beams.size();i++){
            double[] x=beams.get(i).getX();
            double[] y=beams.get(i).getU();
            this.drawPath(g2, x, y, Color.BLUE);
            x2=x[0];
            y2=y[0];
            this.drawLine(g2, x1, y1, x2, y2, 1);
            this.drawString(g2,new String(f.format(y1)),x1, y1,Color.RED);
            this.drawString(g2,new String(f.format(y2)),x2,y2,Color.RED);
            x1=x[x.length-1];
            y1=y[y.length-1];
        }
        x2=L;
        y2=0.;
        this.drawLine(g2, x1, y1, x2, y2, 1);
    }
    private void drawV(Graphics2D g2){
        Vector<core.Beam> beams=domain.getBeams();
        double x1,x2,y1,y2;
        x1=0.;
        y1=0.;
        for(int i=0;i<beams.size();i++){
            double[] x=beams.get(i).getX();
            double[] y=beams.get(i).getV();
            this.drawPath(g2, x, y, Color.BLUE);
            x2=x[0];
            y2=y[0];
            this.drawLine(g2, x1, y1, x2, y2, 1);
            this.drawString(g2,new String(""+y1),x1, y1,Color.RED);
             this.drawString(g2,new String(""+y1),x1, y1,Color.RED);
            this.drawString(g2,new String(""+y2),x2,y2,Color.RED);
            x1=x[x.length-1];
            y1=y[y.length-1];
        }
        x2=L;
        y2=0.;
        this.drawLine(g2, x1, y1, x2, y2, 1);
    }
    private void drawGraph(Graphics2D g2){
        DecimalFormat f=new DecimalFormat("###.00");
        Vector<core.Beam> beams=domain.getBeams();
        double x1,x2,y1,y2;
        x1=0.;
        y1=0.;
        for(int i=0;i<beams.size();i++){
            double[] x=domain.getX(i);
            double[] y=domain.getY(i);
            this.drawPath(g2, x, y, Color.BLUE);
            x2=x[0];
            y2=y[0];
            this.drawLine(g2, x1, y1, x2, y2, 1);
            //this.drawString(g2,new String(f.format(y1)),x1, y1,Color.RED);
            //this.drawString(g2,new String(f.format(y2)),x2,y2,Color.RED);
            x1=x[x.length-1];
            y1=y[y.length-1];
        }
        x2=L;
        y2=0.;
        this.drawLine(g2, x1, y1, x2, y2, 1);
    }
    
    public void drawYAxis(Graphics2D g2, int width, int height){
	 
	// draw ticks
        g2.setStroke(new BasicStroke(1));
	g2.setColor(Color.DARK_GRAY);
	int mark_x = 0;
        for(int i=0;i<9;i++){
            if(i==4) continue;
            float dy=(height-40)/8;
            float y=20+i*dy;
            DecimalFormat f=new DecimalFormat("#0.0E00");
            g2.draw(new Line2D.Double(0, y, 5, y));
            g2.drawString(f.format((y-0.5*height)/resolution_y), 10, y+5);
            mark_x++;
        }
        g2.drawString("Units [kN,m]", width-80, 20);        
    }
            
    @Override
    public void paintComponent(Graphics g) {
	Graphics2D g2 = (Graphics2D) g;
	// Clear window
	int width  = getWidth();
	int height = getHeight();
	g2.setBackground(Color.WHITE);
	g2.clearRect(0, 0, width, height);
        // Check length
        
        if(L>0.){
            resolution_x=width/(L+2);
            double max=domain.getMaxMin()[0];
            resolution_y=getHeight()/(2.5*max);
            originX=resolution_x;
            originY=height/2;
 
            drawCoordinateSystem(g2,width,height);
            drawYAxis(g2,width,height);
            drawBeam(g2);
            drawGraph(g2);
        }
    }
}
