/*
 * MainFrame.java
 *
 * Created on 3 Μάρτιος 2008, 11:08 μμ
 */
package gui;

import core.Domain;
import java.awt.CardLayout;
import java.awt.Component;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.String;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Arrays;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.AbstractButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.text.JTextComponent;
import misc.BareBonesBrowserLaunch;
import misc.XMLParser;

/**
 *
 * @author  fotis
 */
public class MainFrame extends javax.swing.JFrame {

    private Domain domain;

    /** Creates new form MainFrame */
    public MainFrame() {
        try {
            // Set System L&F
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch (UnsupportedLookAndFeelException e) {
            // handle exception
        }
        catch (ClassNotFoundException e) {
            // handle exception
        }
        catch (InstantiationException e) {
            // handle exception
        }
        catch (IllegalAccessException e) {
            // handle exception
        }
        domain = new Domain();
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        propsDialog = new javax.swing.JDialog(this,true);
        generalOK = new javax.swing.JButton();
        generalCancel = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        projectField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        userField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        commentsField = new javax.swing.JTextArea();
        nodeDialog = new javax.swing.JDialog(this,true);
        nodeScrollPane = new javax.swing.JScrollPane();
        nodeTable = new javax.swing.JTable();
        nodeAddButton = new javax.swing.JButton();
        nodeRemButon = new javax.swing.JButton();
        jLabel20 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        nodeGenButton = new javax.swing.JButton();
        jLabel26 = new javax.swing.JLabel();
        nodeFromField = new javax.swing.JFormattedTextField(new DecimalFormat("####0.00"));
        nodeSegmentsField = new javax.swing.JFormattedTextField(NumberFormat.getIntegerInstance());
        nodeToField = new javax.swing.JFormattedTextField(new DecimalFormat("####0.00"));
        jSeparator4 = new javax.swing.JSeparator();
        jSeparator5 = new javax.swing.JSeparator();
        nodeOK = new javax.swing.JButton();
        matDialog = new javax.swing.JDialog(this,true);
        matSoilPanel = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        matSoilKs = new javax.swing.JFormattedTextField();
        matSoilGamma = new javax.swing.JFormattedTextField();
        matDialogOK = new javax.swing.JButton();
        matlDialogCancel = new javax.swing.JButton();
        matBeamPanel = new javax.swing.JPanel();
        jLabel30 = new javax.swing.JLabel();
        jLabel31 = new javax.swing.JLabel();
        jLabel32 = new javax.swing.JLabel();
        matBeamE = new javax.swing.JFormattedTextField();
        matBeamNu = new javax.swing.JFormattedTextField();
        matBeamGamma = new javax.swing.JFormattedTextField();
        secDialog = new javax.swing.JDialog(this,true);
        beamPanel = new javax.swing.JPanel();
        beamDialogOK = new javax.swing.JButton();
        soilDialogCancel2 = new javax.swing.JButton();
        beamSecCombo = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        beamSecCardLayoutPanel = new javax.swing.JPanel();
        beamSecTrpz = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        secTrpzB = new javax.swing.JFormattedTextField();
        secTrpzH = new javax.swing.JFormattedTextField();
        secTrpzB0 = new javax.swing.JFormattedTextField();
        secTrpzH0 = new javax.swing.JFormattedTextField();
        secTrpzH1 = new javax.swing.JFormattedTextField();
        secTrpzH2 = new javax.swing.JFormattedTextField();
        jLabel27 = new javax.swing.JLabel();
        beamSecRect = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();
        jLabel35 = new javax.swing.JLabel();
        secRectB = new javax.swing.JFormattedTextField();
        secRectH = new javax.swing.JFormattedTextField();
        secRectB0 = new javax.swing.JFormattedTextField();
        secRectH0 = new javax.swing.JFormattedTextField();
        secRectH1 = new javax.swing.JFormattedTextField();
        beamSecUser = new javax.swing.JPanel();
        jLabel24 = new javax.swing.JLabel();
        jLabel25 = new javax.swing.JLabel();
        secUserB = new javax.swing.JFormattedTextField();
        secUserH = new javax.swing.JFormattedTextField();
        jLabel28 = new javax.swing.JLabel();
        secUserA = new javax.swing.JFormattedTextField();
        jLabel34 = new javax.swing.JLabel();
        secUserI = new javax.swing.JFormattedTextField();
        loadDialog = new javax.swing.JDialog(this,true);
        loadNodePanel = new javax.swing.JPanel();
        jLabel38 = new javax.swing.JLabel();
        loadNode = new javax.swing.JComboBox();
        jLabel40 = new javax.swing.JLabel();
        loadNodeV = new javax.swing.JFormattedTextField(new DecimalFormat("######0.000"));
        jLabel41 = new javax.swing.JLabel();
        loadNodeM = new javax.swing.JFormattedTextField(new DecimalFormat("######0.000"));
        jSeparator8 = new javax.swing.JSeparator();
        loadNodeSetButton = new javax.swing.JButton();
        jSeparator14 = new javax.swing.JSeparator();
        loadNodeText = new javax.swing.JTextField();
        loadDialogClose = new javax.swing.JButton();
        loadElemPanel = new javax.swing.JPanel();
        jLabel39 = new javax.swing.JLabel();
        loadElem = new javax.swing.JComboBox();
        jLabel43 = new javax.swing.JLabel();
        loadElemPA = new javax.swing.JFormattedTextField(new DecimalFormat("######0.000"));
        jLabel44 = new javax.swing.JLabel();
        loadElemPB = new javax.swing.JFormattedTextField(new DecimalFormat("######0.000"));
        jSeparator9 = new javax.swing.JSeparator();
        loadElemSetButton = new javax.swing.JButton();
        jSeparator15 = new javax.swing.JSeparator();
        loadElemText = new javax.swing.JTextField();
        openFileChooser = new javax.swing.JFileChooser();
        saveFileChooser = new javax.swing.JFileChooser();
        buttonGroup = new javax.swing.ButtonGroup();
        toolBar = new javax.swing.JToolBar();
        newFileButton = new javax.swing.JButton();
        openFileButton = new javax.swing.JButton();
        saveFileButton = new javax.swing.JButton();
        infoButton = new javax.swing.JButton();
        statusBarPabel = new javax.swing.JPanel();
        statusText = new javax.swing.JLabel();
        mainPanel = new javax.swing.JPanel();
        inputPanel = new javax.swing.JPanel();
        inputToolBar = new javax.swing.JToolBar();
        generalButton = new javax.swing.JButton();
        nodeButton = new javax.swing.JButton();
        matButton = new javax.swing.JButton();
        secButton = new javax.swing.JButton();
        loadButton = new javax.swing.JButton();
        drawPanelInput = new gui.DrawPanelInput();
        drawPanelInput.setDomain(domain);
        outputPanel = new javax.swing.JPanel();
        cardPanel = new javax.swing.JPanel();
        drawPanelOutput = new gui.DrawPanelOutput();
        drawPanelOutput.setDomain(domain);
        tablePanel = new javax.swing.JPanel();
        tableScrollPane = new javax.swing.JScrollPane();
        tableOutput = new javax.swing.JTable();
        outputToolBar = new javax.swing.JToolBar();
        solveButton = new javax.swing.JToggleButton();
        tableButton = new javax.swing.JToggleButton();
        displacementButton = new javax.swing.JToggleButton();
        momentButton = new javax.swing.JToggleButton();
        shearButton = new javax.swing.JToggleButton();
        soilPressureButton = new javax.swing.JToggleButton();

        propsDialog.setTitle("General settings");
        propsDialog.setResizable(false);

        generalOK.setText("OK");
        generalOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                generalOKActionPerformed(evt);
            }
        });

        generalCancel.setText("Cancel");
        generalCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                generalCancelActionPerformed(evt);
            }
        });

        jLabel1.setText("Project");

        jLabel2.setText("User");

        jLabel3.setText("Comments");

        commentsField.setColumns(20);
        commentsField.setRows(5);
        jScrollPane1.setViewportView(commentsField);

        javax.swing.GroupLayout propsDialogLayout = new javax.swing.GroupLayout(propsDialog.getContentPane());
        propsDialog.getContentPane().setLayout(propsDialogLayout);
        propsDialogLayout.setHorizontalGroup(
            propsDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(propsDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(propsDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, propsDialogLayout.createSequentialGroup()
                        .addComponent(generalOK, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(generalCancel))
                    .addGroup(propsDialogLayout.createSequentialGroup()
                        .addGroup(propsDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addComponent(jLabel2)
                            .addComponent(jLabel1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(propsDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(userField, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE)
                            .addComponent(projectField, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE))))
                .addContainerGap())
        );
        propsDialogLayout.setVerticalGroup(
            propsDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(propsDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(propsDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(projectField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(propsDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(userField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(propsDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(propsDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(generalCancel)
                    .addComponent(generalOK))
                .addContainerGap())
        );

        propsDialog.pack();

        nodeDialog.setTitle("Nodes");
        nodeDialog.setResizable(false);

        nodeScrollPane.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);

        nodeTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Nodes"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Double.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        nodeTable.setGridColor(new java.awt.Color(255, 255, 255));
        nodeTable.setUpdateSelectionOnSort(false);
        nodeTable.getModel().addTableModelListener(new TableModelListener() {
            public void tableChanged(TableModelEvent e) {
                if(e.getType()==TableModelEvent.UPDATE){
                    nodeTableUpdate();
                }             
            }         
        });
        nodeTable.getColumn("Nodes").setCellRenderer(new DecimalRenderer(new DecimalFormat("###,##0.00")));
        nodeScrollPane.setViewportView(nodeTable);

        nodeAddButton.setText("Add");
        nodeAddButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nodeAddButtonActionPerformed(evt);
            }
        });

        nodeRemButon.setText("Remove");
        nodeRemButon.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nodeRemButonActionPerformed(evt);
            }
        });

        jLabel20.setText("From:");

        jLabel21.setText("To:");

        nodeGenButton.setText("Generate");
        nodeGenButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nodeGenButtonActionPerformed(evt);
            }
        });

        jLabel26.setText("Number of segments:");

        nodeFromField.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        nodeFromField.setValue(new Double(0.));

        nodeSegmentsField.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        nodeSegmentsField.setValue(new Integer(5));

        nodeToField.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        nodeToField.setValue(new Double(10.));

        nodeOK.setText("Close");
        nodeOK.setMaximumSize(new java.awt.Dimension(60, 23));
        nodeOK.setMinimumSize(new java.awt.Dimension(60, 23));
        nodeOK.setPreferredSize(new java.awt.Dimension(60, 23));
        nodeOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nodeOKActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout nodeDialogLayout = new javax.swing.GroupLayout(nodeDialog.getContentPane());
        nodeDialog.getContentPane().setLayout(nodeDialogLayout);
        nodeDialogLayout.setHorizontalGroup(
            nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(nodeDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(nodeScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(nodeOK, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(nodeDialogLayout.createSequentialGroup()
                                .addGroup(nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jLabel21, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addGroup(nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                        .addComponent(jLabel20, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 105, Short.MAX_VALUE)
                                        .addComponent(jLabel26, javax.swing.GroupLayout.Alignment.LEADING)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(nodeToField, javax.swing.GroupLayout.DEFAULT_SIZE, 46, Short.MAX_VALUE)
                                    .addComponent(nodeFromField)
                                    .addComponent(nodeSegmentsField, javax.swing.GroupLayout.DEFAULT_SIZE, 46, Short.MAX_VALUE)))
                            .addComponent(jSeparator4)
                            .addGroup(nodeDialogLayout.createSequentialGroup()
                                .addComponent(nodeAddButton)
                                .addGap(1, 1, 1)
                                .addComponent(nodeRemButon)))
                        .addComponent(nodeGenButton))
                    .addComponent(jSeparator5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 157, Short.MAX_VALUE))
                .addContainerGap())
        );

        nodeDialogLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {nodeAddButton, nodeGenButton, nodeRemButon});

        nodeDialogLayout.setVerticalGroup(
            nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(nodeDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(nodeDialogLayout.createSequentialGroup()
                        .addGroup(nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(nodeRemButon)
                            .addComponent(nodeAddButton))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jSeparator4, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel20)
                            .addComponent(nodeFromField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(nodeToField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel21))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(nodeDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel26)
                            .addComponent(nodeSegmentsField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(nodeGenButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jSeparator5, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(nodeOK, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(nodeScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 168, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        nodeDialog.pack();

        matDialog.setTitle("Material properties");
        matDialog.setMinimumSize(null);
        matDialog.setResizable(false);

        matSoilPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Soil"));

        jLabel8.setText("Ks [kN/m3]");

        jLabel19.setText("γ [kN/m3]");

        matSoilKs.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("#####0.###"))));
        matSoilKs.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        matSoilGamma.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("###0.0#"))));
        matSoilGamma.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        matSoilGamma.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                matSoilGammaActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout matSoilPanelLayout = new javax.swing.GroupLayout(matSoilPanel);
        matSoilPanel.setLayout(matSoilPanelLayout);
        matSoilPanelLayout.setHorizontalGroup(
            matSoilPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(matSoilPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(matSoilPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(matSoilPanelLayout.createSequentialGroup()
                        .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(matSoilKs, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE))
                    .addGroup(matSoilPanelLayout.createSequentialGroup()
                        .addComponent(jLabel19)
                        .addGap(59, 59, 59)
                        .addComponent(matSoilGamma, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)))
                .addContainerGap())
        );
        matSoilPanelLayout.setVerticalGroup(
            matSoilPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(matSoilPanelLayout.createSequentialGroup()
                .addGroup(matSoilPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(matSoilKs, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(matSoilPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel19)
                    .addComponent(matSoilGamma, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        matDialogOK.setText("OK");
        matDialogOK.setMaximumSize(new java.awt.Dimension(65, 23));
        matDialogOK.setMinimumSize(new java.awt.Dimension(65, 23));
        matDialogOK.setPreferredSize(new java.awt.Dimension(65, 23));
        matDialogOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                matDialogOKActionPerformed(evt);
            }
        });

        matlDialogCancel.setText("Cancel");
        matlDialogCancel.setMaximumSize(new java.awt.Dimension(75, 23));
        matlDialogCancel.setMinimumSize(new java.awt.Dimension(75, 23));
        matlDialogCancel.setPreferredSize(new java.awt.Dimension(75, 23));
        matlDialogCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                matlDialogCancelActionPerformed(evt);
            }
        });

        matBeamPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Beam"));

        jLabel30.setText("E [kN/m2]");

        jLabel31.setText("ν");

        jLabel32.setText("γ [kN/m3]");

        matBeamE.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("00.0E00"))));
        matBeamE.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        matBeamNu.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("0.00"))));
        matBeamNu.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        matBeamGamma.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("###0.0#"))));
        matBeamGamma.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        javax.swing.GroupLayout matBeamPanelLayout = new javax.swing.GroupLayout(matBeamPanel);
        matBeamPanel.setLayout(matBeamPanelLayout);
        matBeamPanelLayout.setHorizontalGroup(
            matBeamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(matBeamPanelLayout.createSequentialGroup()
                .addGroup(matBeamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(matBeamPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel32))
                    .addGroup(matBeamPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel31))
                    .addGroup(matBeamPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel30, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(matBeamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(matBeamE, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
                    .addComponent(matBeamNu, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
                    .addComponent(matBeamGamma, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE))
                .addContainerGap())
        );
        matBeamPanelLayout.setVerticalGroup(
            matBeamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(matBeamPanelLayout.createSequentialGroup()
                .addGroup(matBeamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(matBeamE, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel30))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(matBeamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(matBeamNu, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel31))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(matBeamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel32)
                    .addComponent(matBeamGamma, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        javax.swing.GroupLayout matDialogLayout = new javax.swing.GroupLayout(matDialog.getContentPane());
        matDialog.getContentPane().setLayout(matDialogLayout);
        matDialogLayout.setHorizontalGroup(
            matDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(matDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(matDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(matSoilPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, matDialogLayout.createSequentialGroup()
                        .addComponent(matDialogOK, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(matlDialogCancel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(matBeamPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        matDialogLayout.setVerticalGroup(
            matDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, matDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(matSoilPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(matBeamPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(matDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(matDialogOK, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(matlDialogCancel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        matDialog.getAccessibleContext().setAccessibleParent(this);
        matDialog.pack();

        secDialog.setTitle("Beam section properties");
        secDialog.setResizable(false);

        beamDialogOK.setText("OK");
        beamDialogOK.setMaximumSize(new java.awt.Dimension(65, 23));
        beamDialogOK.setMinimumSize(new java.awt.Dimension(65, 23));
        beamDialogOK.setPreferredSize(new java.awt.Dimension(65, 23));
        beamDialogOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                beamDialogOKActionPerformed(evt);
            }
        });

        soilDialogCancel2.setText("Cancel");
        soilDialogCancel2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                soilDialogCancel2ActionPerformed(evt);
            }
        });

        beamSecCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Trapezoidal", "Rectangular", "User" }));
        beamSecCombo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                beamSecComboActionPerformed(evt);
            }
        });

        jLabel4.setBackground(new java.awt.Color(255, 255, 255));
        jLabel4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/SectionTrapezoidal.png"))); // NOI18N
        jLabel4.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        beamSecCardLayoutPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        beamSecCardLayoutPanel.setLayout(new java.awt.CardLayout());

        jLabel10.setText("b [m]");

        jLabel11.setText("h [m]");

        jLabel12.setText("b0 [m]");

        jLabel13.setText("h0 [m]");

        jLabel14.setText("h1 [m]");

        secTrpzB.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secTrpzB.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        secTrpzB.setValue(new Double(2.0));

        secTrpzH.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secTrpzH.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        secTrpzH.setValue(new Double(2.0));

        secTrpzB0.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secTrpzB0.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        secTrpzB0.setValue(new Double(0.5));

        secTrpzH0.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secTrpzH0.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        secTrpzH0.setValue(new Double(0.5));

        secTrpzH1.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secTrpzH1.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        secTrpzH1.setValue(new Double(0.5));

        secTrpzH2.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secTrpzH2.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        secTrpzH2.setValue(new Double(0.5));

        jLabel27.setText("h2 [m]");

        javax.swing.GroupLayout beamSecTrpzLayout = new javax.swing.GroupLayout(beamSecTrpz);
        beamSecTrpz.setLayout(beamSecTrpzLayout);
        beamSecTrpzLayout.setHorizontalGroup(
            beamSecTrpzLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(beamSecTrpzLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(beamSecTrpzLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(beamSecTrpzLayout.createSequentialGroup()
                        .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secTrpzB, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(beamSecTrpzLayout.createSequentialGroup()
                        .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secTrpzH, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(beamSecTrpzLayout.createSequentialGroup()
                        .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secTrpzB0, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(beamSecTrpzLayout.createSequentialGroup()
                        .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secTrpzH0, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(beamSecTrpzLayout.createSequentialGroup()
                        .addComponent(jLabel14, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secTrpzH1, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, beamSecTrpzLayout.createSequentialGroup()
                        .addComponent(jLabel27, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secTrpzH2, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)))
                .addContainerGap())
        );
        beamSecTrpzLayout.setVerticalGroup(
            beamSecTrpzLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(beamSecTrpzLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(beamSecTrpzLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel10)
                    .addComponent(secTrpzB, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecTrpzLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(secTrpzH, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecTrpzLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel12)
                    .addComponent(secTrpzB0, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecTrpzLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(secTrpzH0, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel13))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecTrpzLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(secTrpzH1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel14))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecTrpzLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(secTrpzH2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel27))
                .addContainerGap(78, Short.MAX_VALUE))
        );

        beamSecCardLayoutPanel.add(beamSecTrpz, "card0");

        jLabel17.setText("b [m]");

        jLabel18.setText("h [m]");

        jLabel22.setText("b0 [m]");

        jLabel23.setText("h0 [m]");

        jLabel35.setText("h1 [m]");

        secRectB.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secRectB.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        secRectH.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secRectH.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        secRectB0.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secRectB0.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        secRectH0.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secRectH0.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        secRectH1.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secRectH1.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        javax.swing.GroupLayout beamSecRectLayout = new javax.swing.GroupLayout(beamSecRect);
        beamSecRect.setLayout(beamSecRectLayout);
        beamSecRectLayout.setHorizontalGroup(
            beamSecRectLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(beamSecRectLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(beamSecRectLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(beamSecRectLayout.createSequentialGroup()
                        .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secRectB, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(beamSecRectLayout.createSequentialGroup()
                        .addComponent(jLabel18, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secRectH, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(beamSecRectLayout.createSequentialGroup()
                        .addComponent(jLabel22, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secRectB0, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(beamSecRectLayout.createSequentialGroup()
                        .addComponent(jLabel23, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secRectH0, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, beamSecRectLayout.createSequentialGroup()
                        .addComponent(jLabel35, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secRectH1, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)))
                .addContainerGap())
        );
        beamSecRectLayout.setVerticalGroup(
            beamSecRectLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(beamSecRectLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(beamSecRectLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel17)
                    .addComponent(secRectB, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecRectLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel18)
                    .addComponent(secRectH, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecRectLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel22)
                    .addComponent(secRectB0, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecRectLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(secRectH0, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel23))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecRectLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(secRectH1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel35))
                .addContainerGap(104, Short.MAX_VALUE))
        );

        beamSecCardLayoutPanel.add(beamSecRect, "card1");

        beamSecUser.setDoubleBuffered(false);
        beamSecUser.setPreferredSize(new java.awt.Dimension(100, 100));

        jLabel24.setText("b[m]");

        jLabel25.setText("h[m]");

        secUserB.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secUserB.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        secUserH.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        secUserH.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        jLabel28.setText("A[m2]");

        secUserA.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("0.00E00"))));
        secUserA.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        jLabel34.setText("J [m4]");

        secUserI.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("0.00E00"))));
        secUserI.setHorizontalAlignment(javax.swing.JTextField.TRAILING);

        javax.swing.GroupLayout beamSecUserLayout = new javax.swing.GroupLayout(beamSecUser);
        beamSecUser.setLayout(beamSecUserLayout);
        beamSecUserLayout.setHorizontalGroup(
            beamSecUserLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(beamSecUserLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(beamSecUserLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(beamSecUserLayout.createSequentialGroup()
                        .addComponent(jLabel24, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secUserB, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(beamSecUserLayout.createSequentialGroup()
                        .addComponent(jLabel25, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secUserH, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(beamSecUserLayout.createSequentialGroup()
                        .addComponent(jLabel28, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secUserA, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                    .addGroup(beamSecUserLayout.createSequentialGroup()
                        .addComponent(jLabel34, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(secUserI, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)))
                .addContainerGap())
        );
        beamSecUserLayout.setVerticalGroup(
            beamSecUserLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(beamSecUserLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(beamSecUserLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel24)
                    .addComponent(secUserB, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecUserLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel25)
                    .addComponent(secUserH, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecUserLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel28)
                    .addComponent(secUserA, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamSecUserLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel34)
                    .addComponent(secUserI, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(130, Short.MAX_VALUE))
        );

        beamSecCardLayoutPanel.add(beamSecUser, "card2");

        javax.swing.GroupLayout beamPanelLayout = new javax.swing.GroupLayout(beamPanel);
        beamPanel.setLayout(beamPanelLayout);
        beamPanelLayout.setHorizontalGroup(
            beamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(beamPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(beamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, beamPanelLayout.createSequentialGroup()
                        .addComponent(beamDialogOK, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(soilDialogCancel2, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(beamPanelLayout.createSequentialGroup()
                        .addGroup(beamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, 262, Short.MAX_VALUE)
                            .addComponent(beamSecCombo, 0, 262, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(beamSecCardLayoutPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 245, Short.MAX_VALUE)))
                .addGap(28, 28, 28))
        );
        beamPanelLayout.setVerticalGroup(
            beamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, beamPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(beamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(beamPanelLayout.createSequentialGroup()
                        .addComponent(beamSecCombo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(beamSecCardLayoutPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 243, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(beamPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(beamDialogOK, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(soilDialogCancel2, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        javax.swing.GroupLayout secDialogLayout = new javax.swing.GroupLayout(secDialog.getContentPane());
        secDialog.getContentPane().setLayout(secDialogLayout);
        secDialogLayout.setHorizontalGroup(
            secDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(beamPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        secDialogLayout.setVerticalGroup(
            secDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(beamPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        secDialog.pack();

        loadDialog.setTitle("Loads");
        loadDialog.setResizable(false);

        loadNodePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Nodal load"));

        jLabel38.setText("At node:");

        loadNode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadNodeActionPerformed(evt);
            }
        });

        jLabel40.setText("V[kN]");

        loadNodeV.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        loadNodeV.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        loadNodeV.setValue(new Double(0.));

        jLabel41.setText("M[kNm]");

        loadNodeM.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("##0.00"))));
        loadNodeM.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        loadNodeM.setValue(new Double(0.));

        loadNodeSetButton.setText("Set");
        loadNodeSetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadNodeSetButtonActionPerformed(evt);
            }
        });

        loadNodeText.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        loadNodeText.setEnabled(false);

        javax.swing.GroupLayout loadNodePanelLayout = new javax.swing.GroupLayout(loadNodePanel);
        loadNodePanel.setLayout(loadNodePanelLayout);
        loadNodePanelLayout.setHorizontalGroup(
            loadNodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(loadNodePanelLayout.createSequentialGroup()
                .addGroup(loadNodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(loadNodePanelLayout.createSequentialGroup()
                        .addComponent(jLabel38, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(loadNode, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(loadNodeText, javax.swing.GroupLayout.DEFAULT_SIZE, 60, Short.MAX_VALUE))
                    .addGroup(loadNodePanelLayout.createSequentialGroup()
                        .addComponent(jLabel40, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(loadNodeV, javax.swing.GroupLayout.DEFAULT_SIZE, 142, Short.MAX_VALUE))
                    .addGroup(loadNodePanelLayout.createSequentialGroup()
                        .addComponent(jLabel41, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(loadNodeM, javax.swing.GroupLayout.DEFAULT_SIZE, 142, Short.MAX_VALUE))
                    .addComponent(jSeparator8, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE)
                    .addGroup(loadNodePanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jSeparator14, javax.swing.GroupLayout.DEFAULT_SIZE, 197, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, loadNodePanelLayout.createSequentialGroup()
                        .addContainerGap(158, Short.MAX_VALUE)
                        .addComponent(loadNodeSetButton)))
                .addContainerGap())
        );

        loadNodePanelLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jLabel40, jLabel41});

        loadNodePanelLayout.setVerticalGroup(
            loadNodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(loadNodePanelLayout.createSequentialGroup()
                .addGroup(loadNodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(loadNodeText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(loadNode, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel38))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator8, javax.swing.GroupLayout.PREFERRED_SIZE, 8, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(loadNodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(loadNodeV, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel40))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(loadNodePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(loadNodeM, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel41))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator14, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(loadNodeSetButton))
        );

        loadDialogClose.setText("Close");
        loadDialogClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadDialogCloseActionPerformed(evt);
            }
        });

        loadElemPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Elemental load"));

        jLabel39.setText("At element:");

        loadElem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadElemActionPerformed(evt);
            }
        });

        jLabel43.setText("pA[kN]");

        loadElemPA.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        loadElemPA.setValue(new Double(0.));

        jLabel44.setText("pB[kN]");

        loadElemPB.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        loadElemPB.setValue(new Double(0.));

        loadElemSetButton.setText("Set");
        loadElemSetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadElemSetButtonActionPerformed(evt);
            }
        });

        loadElemText.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        loadElemText.setEnabled(false);

        javax.swing.GroupLayout loadElemPanelLayout = new javax.swing.GroupLayout(loadElemPanel);
        loadElemPanel.setLayout(loadElemPanelLayout);
        loadElemPanelLayout.setHorizontalGroup(
            loadElemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(loadElemPanelLayout.createSequentialGroup()
                .addGroup(loadElemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(loadElemPanelLayout.createSequentialGroup()
                        .addComponent(jLabel39, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(loadElem, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(loadElemText, javax.swing.GroupLayout.DEFAULT_SIZE, 62, Short.MAX_VALUE))
                    .addComponent(jSeparator9, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 209, Short.MAX_VALUE)
                    .addGroup(loadElemPanelLayout.createSequentialGroup()
                        .addGroup(loadElemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel44, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel43, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(loadElemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(loadElemPA, javax.swing.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE)
                            .addComponent(loadElemPB, javax.swing.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, loadElemPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jSeparator15, javax.swing.GroupLayout.DEFAULT_SIZE, 199, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, loadElemPanelLayout.createSequentialGroup()
                        .addContainerGap(160, Short.MAX_VALUE)
                        .addComponent(loadElemSetButton)))
                .addContainerGap())
        );
        loadElemPanelLayout.setVerticalGroup(
            loadElemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(loadElemPanelLayout.createSequentialGroup()
                .addGroup(loadElemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(loadElem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(loadElemText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel39))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator9, javax.swing.GroupLayout.PREFERRED_SIZE, 8, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(loadElemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel43)
                    .addComponent(loadElemPA, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(loadElemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel44)
                    .addComponent(loadElemPB, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator15, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(loadElemSetButton))
        );

        javax.swing.GroupLayout loadDialogLayout = new javax.swing.GroupLayout(loadDialog.getContentPane());
        loadDialog.getContentPane().setLayout(loadDialogLayout);
        loadDialogLayout.setHorizontalGroup(
            loadDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(loadDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(loadNodePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(loadElemPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, loadDialogLayout.createSequentialGroup()
                .addContainerGap(425, Short.MAX_VALUE)
                .addComponent(loadDialogClose)
                .addContainerGap())
        );
        loadDialogLayout.setVerticalGroup(
            loadDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(loadDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(loadDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(loadNodePanel, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(loadElemPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(loadDialogClose)
                .addContainerGap())
        );

        loadDialog.pack();

        saveFileChooser.setDialogType(javax.swing.JFileChooser.SAVE_DIALOG);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("jWinkler");
        setFocusable(false);

        toolBar.setFloatable(false);
        toolBar.setRollover(true);
        toolBar.setAlignmentX(5.0F);
        toolBar.setMinimumSize(new java.awt.Dimension(50, 50));

        newFileButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/new.png"))); // NOI18N
        newFileButton.setToolTipText("New");
        newFileButton.setFocusable(false);
        newFileButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        newFileButton.setMaximumSize(new java.awt.Dimension(48, 48));
        newFileButton.setMinimumSize(new java.awt.Dimension(48, 48));
        newFileButton.setPreferredSize(new java.awt.Dimension(48, 48));
        newFileButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        newFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newFileButtonActionPerformed(evt);
            }
        });
        toolBar.add(newFileButton);

        openFileButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/open.png"))); // NOI18N
        openFileButton.setToolTipText("Open");
        openFileButton.setFocusable(false);
        openFileButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        openFileButton.setMaximumSize(new java.awt.Dimension(48, 48));
        openFileButton.setMinimumSize(new java.awt.Dimension(48, 48));
        openFileButton.setPreferredSize(new java.awt.Dimension(48, 48));
        openFileButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        openFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openFileButtonActionPerformed(evt);
            }
        });
        toolBar.add(openFileButton);

        saveFileButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/save.png"))); // NOI18N
        saveFileButton.setToolTipText("Save");
        saveFileButton.setFocusable(false);
        saveFileButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        saveFileButton.setMaximumSize(new java.awt.Dimension(48, 48));
        saveFileButton.setMinimumSize(new java.awt.Dimension(48, 48));
        saveFileButton.setPreferredSize(new java.awt.Dimension(48, 48));
        saveFileButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        saveFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveFileButtonActionPerformed(evt);
            }
        });
        toolBar.add(saveFileButton);

        infoButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/info.png"))); // NOI18N
        infoButton.setToolTipText("Info");
        infoButton.setFocusable(false);
        infoButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        infoButton.setMaximumSize(new java.awt.Dimension(48, 48));
        infoButton.setMinimumSize(new java.awt.Dimension(48, 48));
        infoButton.setPreferredSize(new java.awt.Dimension(48, 48));
        infoButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        infoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                infoButtonActionPerformed(evt);
            }
        });
        toolBar.add(infoButton);

        getContentPane().add(toolBar, java.awt.BorderLayout.PAGE_START);

        statusBarPabel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        statusBarPabel.setMinimumSize(new java.awt.Dimension(100, 20));
        statusBarPabel.setPreferredSize(new java.awt.Dimension(100, 20));

        statusText.setText("jLabel3");
        statusText.setMaximumSize(new java.awt.Dimension(34, 20));
        statusText.setMinimumSize(new java.awt.Dimension(34, 20));
        statusText.setPreferredSize(new java.awt.Dimension(34, 20));

        javax.swing.GroupLayout statusBarPabelLayout = new javax.swing.GroupLayout(statusBarPabel);
        statusBarPabel.setLayout(statusBarPabelLayout);
        statusBarPabelLayout.setHorizontalGroup(
            statusBarPabelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, statusBarPabelLayout.createSequentialGroup()
                .addComponent(statusText, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(992, 992, 992))
        );
        statusBarPabelLayout.setVerticalGroup(
            statusBarPabelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusBarPabelLayout.createSequentialGroup()
                .addGap(323, 323, 323)
                .addComponent(statusText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        getContentPane().add(statusBarPabel, java.awt.BorderLayout.PAGE_END);

        mainPanel.setLayout(new java.awt.GridLayout(2, 2));

        inputPanel.setLayout(new java.awt.BorderLayout());

        inputToolBar.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        inputToolBar.setFloatable(false);
        inputToolBar.setOrientation(1);
        inputToolBar.setRollover(true);

        generalButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/settings.png"))); // NOI18N
        generalButton.setToolTipText("Project properties");
        generalButton.setFocusable(false);
        generalButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        generalButton.setMaximumSize(new java.awt.Dimension(48, 48));
        generalButton.setMinimumSize(new java.awt.Dimension(48, 48));
        generalButton.setPreferredSize(new java.awt.Dimension(48, 48));
        generalButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        generalButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                generalButtonActionPerformed(evt);
            }
        });
        inputToolBar.add(generalButton);

        nodeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/nodes.png"))); // NOI18N
        nodeButton.setToolTipText("Nodes");
        nodeButton.setFocusable(false);
        nodeButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        nodeButton.setMaximumSize(new java.awt.Dimension(48, 48));
        nodeButton.setMinimumSize(new java.awt.Dimension(48, 48));
        nodeButton.setPreferredSize(new java.awt.Dimension(48, 48));
        nodeButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        nodeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nodeButtonActionPerformed(evt);
            }
        });
        inputToolBar.add(nodeButton);

        matButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/materials.png"))); // NOI18N
        matButton.setToolTipText("Material properties");
        matButton.setFocusable(false);
        matButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        matButton.setMaximumSize(new java.awt.Dimension(48, 48));
        matButton.setMinimumSize(new java.awt.Dimension(48, 48));
        matButton.setPreferredSize(new java.awt.Dimension(48, 48));
        matButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        matButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                matButtonActionPerformed(evt);
            }
        });
        inputToolBar.add(matButton);

        secButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/section.png"))); // NOI18N
        secButton.setToolTipText("Beam section properties");
        secButton.setFocusable(false);
        secButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        secButton.setMaximumSize(new java.awt.Dimension(48, 48));
        secButton.setMinimumSize(new java.awt.Dimension(48, 48));
        secButton.setPreferredSize(new java.awt.Dimension(48, 48));
        secButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        secButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                secButtonActionPerformed(evt);
            }
        });
        inputToolBar.add(secButton);

        loadButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/loads.png"))); // NOI18N
        loadButton.setToolTipText("Loads");
        loadButton.setFocusable(false);
        loadButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        loadButton.setMaximumSize(new java.awt.Dimension(48, 48));
        loadButton.setMinimumSize(new java.awt.Dimension(48, 48));
        loadButton.setPreferredSize(new java.awt.Dimension(48, 48));
        loadButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        loadButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadButtonActionPerformed(evt);
            }
        });
        inputToolBar.add(loadButton);

        inputPanel.add(inputToolBar, java.awt.BorderLayout.LINE_START);

        drawPanelInput.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout drawPanelInputLayout = new javax.swing.GroupLayout(drawPanelInput);
        drawPanelInput.setLayout(drawPanelInputLayout);
        drawPanelInputLayout.setHorizontalGroup(
            drawPanelInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 361, Short.MAX_VALUE)
        );
        drawPanelInputLayout.setVerticalGroup(
            drawPanelInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 660, Short.MAX_VALUE)
        );

        inputPanel.add(drawPanelInput, java.awt.BorderLayout.CENTER);

        mainPanel.add(inputPanel);

        outputPanel.setLayout(new java.awt.BorderLayout());

        cardPanel.setLayout(new java.awt.CardLayout());

        drawPanelOutput.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout drawPanelOutputLayout = new javax.swing.GroupLayout(drawPanelOutput);
        drawPanelOutput.setLayout(drawPanelOutputLayout);
        drawPanelOutputLayout.setHorizontalGroup(
            drawPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 361, Short.MAX_VALUE)
        );
        drawPanelOutputLayout.setVerticalGroup(
            drawPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 660, Short.MAX_VALUE)
        );

        cardPanel.add(drawPanelOutput, "card0");

        tablePanel.setLayout(new java.awt.BorderLayout());

        tableOutput.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "beam", "node", "displacements [m]", "rotations [m]", "S [kN]", "shear forces [kN]", "soil pressures [kN]"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tableOutput.setColumnSelectionAllowed(true);
        tableOutput.getTableHeader().setReorderingAllowed(false);
        tableScrollPane.setViewportView(tableOutput);
        tableOutput.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

        tablePanel.add(tableScrollPane, java.awt.BorderLayout.CENTER);

        cardPanel.add(tablePanel, "card1");

        outputPanel.add(cardPanel, java.awt.BorderLayout.CENTER);

        outputToolBar.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        outputToolBar.setFloatable(false);
        outputToolBar.setOrientation(1);
        outputToolBar.setRollover(true);

        solveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/calc.png"))); // NOI18N
        solveButton.setToolTipText("Solve");
        solveButton.setFocusable(false);
        solveButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        solveButton.setMaximumSize(new java.awt.Dimension(48, 48));
        solveButton.setMinimumSize(new java.awt.Dimension(48, 48));
        solveButton.setPreferredSize(new java.awt.Dimension(48, 48));
        solveButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        solveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                solveButtonActionPerformed(evt);
            }
        });
        outputToolBar.add(solveButton);

        buttonGroup.add(tableButton);
        tableButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/cal.png"))); // NOI18N
        tableButton.setToolTipText("Tables");
        tableButton.setEnabled(false);
        tableButton.setFocusable(false);
        tableButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        tableButton.setMaximumSize(new java.awt.Dimension(48, 48));
        tableButton.setMinimumSize(new java.awt.Dimension(48, 48));
        tableButton.setPreferredSize(new java.awt.Dimension(48, 48));
        tableButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        tableButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tableButtonActionPerformed(evt);
            }
        });
        outputToolBar.add(tableButton);

        buttonGroup.add(displacementButton);
        displacementButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/displacements.png"))); // NOI18N
        displacementButton.setToolTipText("Displacements");
        displacementButton.setEnabled(false);
        displacementButton.setFocusable(false);
        displacementButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        displacementButton.setMaximumSize(new java.awt.Dimension(48, 48));
        displacementButton.setMinimumSize(new java.awt.Dimension(48, 48));
        displacementButton.setPreferredSize(new java.awt.Dimension(48, 48));
        displacementButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        displacementButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                displacementButtonActionPerformed(evt);
            }
        });
        outputToolBar.add(displacementButton);

        buttonGroup.add(momentButton);
        momentButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/moments.png"))); // NOI18N
        momentButton.setToolTipText("Moments");
        momentButton.setEnabled(false);
        momentButton.setFocusable(false);
        momentButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        momentButton.setMaximumSize(new java.awt.Dimension(48, 48));
        momentButton.setMinimumSize(new java.awt.Dimension(48, 48));
        momentButton.setPreferredSize(new java.awt.Dimension(48, 48));
        momentButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        momentButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                momentButtonActionPerformed(evt);
            }
        });
        outputToolBar.add(momentButton);

        buttonGroup.add(shearButton);
        shearButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/shear.png"))); // NOI18N
        shearButton.setToolTipText("Shear forces");
        shearButton.setEnabled(false);
        shearButton.setFocusable(false);
        shearButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        shearButton.setMaximumSize(new java.awt.Dimension(48, 48));
        shearButton.setMinimumSize(new java.awt.Dimension(48, 48));
        shearButton.setPreferredSize(new java.awt.Dimension(48, 48));
        shearButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        shearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                shearButtonActionPerformed(evt);
            }
        });
        outputToolBar.add(shearButton);

        buttonGroup.add(soilPressureButton);
        soilPressureButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/pressures.png"))); // NOI18N
        soilPressureButton.setToolTipText("Soil pressures");
        soilPressureButton.setEnabled(false);
        soilPressureButton.setFocusable(false);
        soilPressureButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        soilPressureButton.setMaximumSize(new java.awt.Dimension(48, 48));
        soilPressureButton.setMinimumSize(new java.awt.Dimension(48, 48));
        soilPressureButton.setPreferredSize(new java.awt.Dimension(48, 48));
        soilPressureButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        soilPressureButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                soilPressureButtonActionPerformed(evt);
            }
        });
        outputToolBar.add(soilPressureButton);

        outputPanel.add(outputToolBar, java.awt.BorderLayout.LINE_START);

        mainPanel.add(outputPanel);

        getContentPane().add(mainPanel, java.awt.BorderLayout.CENTER);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-842)/2, (screenSize.height-768)/2, 842, 768);
    }// </editor-fold>//GEN-END:initComponents
    private void displacementButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_displacementButtonActionPerformed
        AbstractButton abstractButton = (AbstractButton) evt.getSource();
        boolean selected = abstractButton.getModel().isSelected();
        if(selected){
            CardLayout cl = (CardLayout)(cardPanel.getLayout());
            cl.show(cardPanel, "card0");
        }
        domain.setResultsType(Domain.ResultsType.U);
        drawPanelOutput.repaint();
}//GEN-LAST:event_displacementButtonActionPerformed

    private void momentButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_momentButtonActionPerformed
        AbstractButton abstractButton = (AbstractButton) evt.getSource();
        boolean selected = abstractButton.getModel().isSelected();
        if(selected){
            CardLayout cl = (CardLayout)(cardPanel.getLayout());
            cl.show(cardPanel, "card0");
        }
        domain.setResultsType(Domain.ResultsType.M);
        drawPanelOutput.repaint();
}//GEN-LAST:event_momentButtonActionPerformed

    private void shearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_shearButtonActionPerformed
        AbstractButton abstractButton = (AbstractButton) evt.getSource();
        boolean selected = abstractButton.getModel().isSelected();
        if(selected){
            CardLayout cl = (CardLayout)(cardPanel.getLayout());
            cl.show(cardPanel, "card0");
        }
        domain.setResultsType(Domain.ResultsType.V);
        drawPanelOutput.repaint();
}//GEN-LAST:event_shearButtonActionPerformed

    private void soilPressureButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_soilPressureButtonActionPerformed
        AbstractButton abstractButton = (AbstractButton) evt.getSource();
        boolean selected = abstractButton.getModel().isSelected();
        if(selected){
            CardLayout cl = (CardLayout)(cardPanel.getLayout());
            cl.show(cardPanel, "card0");
        }
        domain.setResultsType(Domain.ResultsType.P);
        drawPanelOutput.repaint();
}//GEN-LAST:event_soilPressureButtonActionPerformed

    private void generalButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_generalButtonActionPerformed
        propsDialog.setLocationRelativeTo(this);
        projectField.setText(domain.getProject());
        userField.setText(domain.getUser());
        commentsField.setText(domain.getComments());
        propsDialog.setVisible(true);
}//GEN-LAST:event_generalButtonActionPerformed

    private void matButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_matButtonActionPerformed
        matSoilKs.setValue(domain.getSoilMat().getKs());
        matSoilGamma.setValue(domain.getSoilMat().getGamma());
        matBeamE.setValue(domain.getBeamMat().getE());
        matBeamNu.setValue(domain.getBeamMat().getNu());
        matBeamGamma.setValue(domain.getBeamMat().getGamma());
        matDialog.setLocationRelativeTo(this);
        matDialog.setVisible(true);
}//GEN-LAST:event_matButtonActionPerformed

    private void secButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_secButtonActionPerformed
        secDialog.setLocationRelativeTo(this);
        secDialog.setVisible(true);
}//GEN-LAST:event_secButtonActionPerformed

    private void solveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_solveButtonActionPerformed
        domain.solve();
        AbstractButton abstractButton = (AbstractButton) evt.getSource();
        boolean selected = abstractButton.getModel().isSelected();
        if(selected){
            tableButton.setEnabled(true);
            displacementButton.setEnabled(true);
            momentButton.setEnabled(true);
            shearButton.setEnabled(true);
            soilPressureButton.setEnabled(true);
            buttonGroup.clearSelection();
        } else {
            outputClear();
            buttonGroup.clearSelection();
            displacementButton.setEnabled(false);
            momentButton.setEnabled(false);
            shearButton.setEnabled(false);
            soilPressureButton.setEnabled(false);          
        }
}//GEN-LAST:event_solveButtonActionPerformed

    private void matlDialogCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_matlDialogCancelActionPerformed
        matDialog.setVisible(false);
}//GEN-LAST:event_matlDialogCancelActionPerformed

    private void newFileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newFileButtonActionPerformed
        domain.reset();
        drawPanelInput.repaint();
        drawPanelOutput.repaint();
}//GEN-LAST:event_newFileButtonActionPerformed

    private void loadDialogCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadDialogCloseActionPerformed
        loadDialog.setVisible(false);
}//GEN-LAST:event_loadDialogCloseActionPerformed

    private void loadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadButtonActionPerformed
        // Create formatters
        loadNode.removeAllItems();
        loadElem.removeAllItems();

        int size = domain.getNodes().size();
        for (int i = 0; i < size; i++) {
            loadNode.addItem(i + 1);
        }
        for (int i = 0; i < size - 1; i++) {
            loadElem.addItem(i + 1);
        }
        loadDialog.setLocationRelativeTo(this);
        loadDialog.setVisible(true);
}//GEN-LAST:event_loadButtonActionPerformed

    private void beamDialogOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_beamDialogOKActionPerformed
        String choice = (String) beamSecCombo.getSelectedItem();
        try {
            if (choice.equals("Trapezoidal")) {
                double b = ((Number) secTrpzB.getValue()).doubleValue();
                double h = ((Number) secTrpzH.getValue()).doubleValue();
                double b0 = ((Number) secTrpzB0.getValue()).doubleValue();
                double h0 = ((Number) secTrpzH0.getValue()).doubleValue();
                double h1 = ((Number) secTrpzH1.getValue()).doubleValue();
                double h2 = ((Number) secTrpzH2.getValue()).doubleValue();
                core.SectionTrapezoidal sec = new core.SectionTrapezoidal(b, h, b0, h0, h1, h2);
                domain.setBeamSec(sec);
            } else if (choice.equals("Rectangular")) {
                double b = ((Number) secRectB.getValue()).doubleValue();
                double h = ((Number) secRectH.getValue()).doubleValue();
                double b0 = ((Number) secRectB0.getValue()).doubleValue();
                double h0 = ((Number) secRectH0.getValue()).doubleValue();
                double h1 = ((Number) secRectH1.getValue()).doubleValue();
                core.SectionRectangle sec = new core.SectionRectangle(b, h, b0, h0, h1);
                domain.setBeamSec(sec);
            } else if (choice.equals("User")) {
                double b = ((Number) secUserB.getValue()).doubleValue();
                double h = ((Number) secUserH.getValue()).doubleValue();
                double A = ((Number) secUserA.getValue()).doubleValue();
                double I = ((Number) secUserI.getValue()).doubleValue();
                core.SectionUser sec = new core.SectionUser(b, h, A, I);
                domain.setBeamSec(sec);
            }
            secDialog.setVisible(false);
        } catch(java.lang.NullPointerException e){
            JOptionPane.showMessageDialog(drawPanelInput, "Missing or insufficient data.",
                    "Data error",JOptionPane.ERROR_MESSAGE);
        }
        outputClear();
        drawPanelInput.repaint();       

}//GEN-LAST:event_beamDialogOKActionPerformed

    private void soilDialogCancel2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_soilDialogCancel2ActionPerformed
        secDialog.setVisible(false);
    }//GEN-LAST:event_soilDialogCancel2ActionPerformed

    private void beamSecComboActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_beamSecComboActionPerformed
        JComboBox cb = (JComboBox) evt.getSource();
        String choice = (String) cb.getSelectedItem();
        CardLayout cl = (CardLayout) (beamSecCardLayoutPanel.getLayout());
        if (choice.equals("Trapezoidal")) {
            jLabel4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/SectionTrapezoidal.png")));
            cl.show(beamSecCardLayoutPanel, "card0");
        } else if (choice.equals("Rectangular")) {
            jLabel4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/SectionRectangular.png")));
            cl.show(beamSecCardLayoutPanel, "card1");
        } else if (choice.equals("User")) {
            jLabel4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/SectionUser.png")));
            cl.show(beamSecCardLayoutPanel, "card2");
        }
}//GEN-LAST:event_beamSecComboActionPerformed

    private void openFileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openFileButtonActionPerformed
        int option = openFileChooser.showDialog(this, "Open");
        if (option == JFileChooser.APPROVE_OPTION) {
            try {
                File file = openFileChooser.getSelectedFile();
                XMLParser parser =new XMLParser();
                parser.parse(domain, file);
            } catch (IOException e) {
                JOptionPane.showMessageDialog(this,
                    "An error has occurred while reading file.");
            }
            drawPanelInput.init();
            drawPanelInput.repaint();
            outputClear();
        }
    //this.domain=null;
    //this.domain=new parser().parse(outFile);
    }//GEN-LAST:event_openFileButtonActionPerformed

    private void saveFileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveFileButtonActionPerformed
        int action = saveFileChooser.showDialog(this, "Save");
        if (action != JFileChooser.APPROVE_OPTION) {
            // User has canceled, or an error occurred.
            return;
        }
        File file = saveFileChooser.getSelectedFile();
        if (file.exists()) {
            // If file already exists, ask before replacing it.
            action = JOptionPane.showConfirmDialog(this,
                    "Replace existing file?");
            if (action != JOptionPane.YES_OPTION) {
                return;
            }
        }
        try {
            // Create a PrintWriter for writing to the specified
            // file and write the text from the window to that stream.
            PrintWriter printWriter = new PrintWriter(new FileWriter(file));
            printWriter.print(domain.toString());
            if (printWriter.checkError()) {
                throw new IOException("Error while writing to file.");
            }
            printWriter.close();
        } catch (IOException e) {
            // Some error has occurred while trying to write.
            // Show an error message
            JOptionPane.showMessageDialog(this,
                    "Sorry, an error has occurred:\n" + e.getMessage());
        }
    }//GEN-LAST:event_saveFileButtonActionPerformed

    private void infoButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_infoButtonActionPerformed
        //BareBonesBrowserLaunch.openURL("http://users.auth.gr/fkar/jWinkler/jWinkler/doc/manual.html");
        BareBonesBrowserLaunch.openURL("http://edusoft.civil.auth.gr/TG1600/jWinkler/doc/manual.html");
}//GEN-LAST:event_infoButtonActionPerformed

    /**
     * Delete a row from the table.
     * Used to delete a node.
     * @param evt
     */
    /**
     * Add a row to the table.
     * Used to add a node.
     * @param evt
     */
    /**
     * Shows node dialog.
     * It also loads node coordinates from the domain.
     * @param evt
     */
    private void nodeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nodeButtonActionPerformed
        // Clear node table
        DefaultTableModel tableModel = (DefaultTableModel) nodeTable.getModel();
        while (tableModel.getRowCount() != 0) {
            tableModel.removeRow(tableModel.getRowCount() - 1);
        }
        // Refill node table with domain nodes
        Vector<core.Node> nodes = domain.getNodes();
        for (int i = 0; i < nodes.size(); i++) {
            double x = nodes.get(i).getX();
            tableModel.addRow(new Object[]{x});
        }
        // Set position of the window and show
        nodeDialog.setLocationRelativeTo(this);
        nodeDialog.setVisible(true);
 
}//GEN-LAST:event_nodeButtonActionPerformed

    /**
     * Hides nodal window.
     * @param evt
     */
    private void nodeOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nodeOKActionPerformed
        // Hide window
        nodeDialog.setVisible(false);
        // Draw beam
        drawPanelInput.repaint();      
    }//GEN-LAST:event_nodeOKActionPerformed

    /**
     * Updates nodal table.
     * Elements are also created.
     * All loads/results are cleared. 
     */
    private void nodeTableUpdate() {
        // Get node table and sort iy
        DefaultTableModel tableModel = (DefaultTableModel) nodeTable.getModel();
        int size = tableModel.getRowCount();
        double nodalCoords[] = new double[size];
        for (int i = 0; i < size; i++) {
            if (tableModel.getValueAt(i, 0) == null) {
                nodalCoords[i] = 0.;
            } else {
                nodalCoords[i] = ((Number) tableModel.getValueAt(i, 0)).doubleValue();
            }
        }
        Arrays.sort(nodalCoords);
        // Clear node table
        while (tableModel.getRowCount() != 0) {
            tableModel.removeRow(tableModel.getRowCount() - 1);
        }
        // Refill node table with sorted values
        for (int i = 0; i < size; i++) {
            if (i > 0 && nodalCoords[i] == nodalCoords[i - 1]) {
                continue;
            }
            double x = nodalCoords[i];
            tableModel.addRow(new Object[]{x});
        }
        // Set nodal Vector
        Vector<core.Node> nodes = new Vector<core.Node>();
        for (int i = 0; i < tableModel.getRowCount(); i++) {
            int id = i + 1;
            double x = ((Number) tableModel.getValueAt(i, 0)).doubleValue();
            nodes.add(new core.Node(id, x));
        }
        domain.setNodes(nodes);

        // Clear Output
        outputClear();
        
        // Init drawPanels
        drawPanelInput.init();
        drawPanelOutput.init();

        // Repaint the input/output panel
        drawPanelInput.repaint();
        drawPanelOutput.repaint();
    }

    private void matSoilGammaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_matSoilGammaActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_matSoilGammaActionPerformed

    private void loadNodeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadNodeActionPerformed
        int id = loadNode.getSelectedIndex();
        if (id > -1) {
            NumberFormat dblFormatter = new DecimalFormat("##0.000");
            loadNodeText.setText(dblFormatter.format(domain.getNodes().get(id).getX()));
            loadNodeV.setValue(domain.getNodes().get(id).getF()[0]);
            loadNodeM.setValue(domain.getNodes().get(id).getF()[1]);
        }
    }//GEN-LAST:event_loadNodeActionPerformed

    private void loadElemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadElemActionPerformed
        int id = loadElem.getSelectedIndex();
        if (id > -1) {
            loadElemText.setText((id + 1) + " - " + (id + 2));
            loadElemPA.setValue(domain.getBeams().get(id).getFext()[0]);
            loadElemPB.setValue(domain.getBeams().get(id).getFext()[1]);
        }
    }//GEN-LAST:event_loadElemActionPerformed

    private void loadNodeSetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadNodeSetButtonActionPerformed
        int id = loadNode.getSelectedIndex();
        double V = ((Number) loadNodeV.getValue()).doubleValue();
        double M = ((Number) loadNodeM.getValue()).doubleValue();
        domain.getNodes().get(id).setLoad(V, M);
        drawPanelInput.repaint();
        outputClear();
}//GEN-LAST:event_loadNodeSetButtonActionPerformed

    private void nodeGenButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nodeGenButtonActionPerformed
        double x1 = ((Number) nodeFromField.getValue()).doubleValue();
        double x2 = ((Number) nodeToField.getValue()).doubleValue();
        int n = ((Number) nodeSegmentsField.getValue()).intValue();
        if (n > 0) {
            DefaultTableModel tableModel = (DefaultTableModel) nodeTable.getModel();
            for (int i = 0; i < n + 1; i++) {
                tableModel.addRow(new Object[]{new Double(x1 + i * (x2 - x1) / n)});
            }
        }
        nodeTableUpdate();
    }//GEN-LAST:event_nodeGenButtonActionPerformed

    private void nodeRemButonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nodeRemButonActionPerformed
        int row = nodeTable.getSelectedRow();
        if (row != -1) {
            ((DefaultTableModel) nodeTable.getModel()).removeRow(row);
            nodeTable.addNotify();
        }
        nodeTableUpdate();
    }//GEN-LAST:event_nodeRemButonActionPerformed

    private void nodeAddButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nodeAddButtonActionPerformed
        DefaultTableModel tableModel = (DefaultTableModel) nodeTable.getModel();
        tableModel.addRow(new Object[]{(double) 0.00});
        int row = nodeTable.getRowCount() - 1;
        if (nodeTable.editCellAt(row, 0)) {
            Component tec = nodeTable.getEditorComponent();
            tec.requestFocus();
            ((JTextComponent) tec).selectAll();
        }
    }//GEN-LAST:event_nodeAddButtonActionPerformed

    private void loadElemSetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadElemSetButtonActionPerformed
        int id = loadElem.getSelectedIndex();
        double pA = ((Number) loadElemPA.getValue()).doubleValue();
        double pB = ((Number) loadElemPB.getValue()).doubleValue();
        domain.getBeams().get(id).setLoad(pA, pB);
        drawPanelInput.repaint();
        outputClear();
    }//GEN-LAST:event_loadElemSetButtonActionPerformed

    private void generalOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_generalOKActionPerformed
        domain.setProject(projectField.getText());
        domain.setUser(userField.getText());
        domain.setComments(commentsField.getText());
        propsDialog.setVisible(false);
}//GEN-LAST:event_generalOKActionPerformed

    private void generalCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_generalCancelActionPerformed
        propsDialog.setVisible(false);
}//GEN-LAST:event_generalCancelActionPerformed

    private void matDialogOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_matDialogOKActionPerformed
        double Ks = ((Number) matSoilKs.getValue()).doubleValue();
        double gammaSoil = ((Number) matSoilGamma.getValue()).doubleValue();
        double E = ((Number) matBeamE.getValue()).doubleValue();
        double nu = ((Number) matBeamNu.getValue()).doubleValue();
        double gammaBeam = ((Number) matBeamGamma.getValue()).doubleValue();
        domain.setSoilMat(gammaSoil, Ks);
        domain.setBeamMat(gammaBeam, E, nu);
        outputClear();
        drawPanelInput.repaint();
        matDialog.setVisible(false);
    }//GEN-LAST:event_matDialogOKActionPerformed

    private void tableButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tableButtonActionPerformed
        AbstractButton abstractButton = (AbstractButton) evt.getSource();
        boolean selected = abstractButton.getModel().isSelected();
        if(selected){
            CardLayout cl = (CardLayout)(cardPanel.getLayout());
            cl.show(cardPanel, "card1");
        }
         DefaultTableModel dataModel=new DefaultTableModel(domain.getTable(),
                new String[]{"beam","node","displacements [m]","rotations [rad]","moments [kNm]","shear forces [kN]","soil pressures [kN]"});
        tableOutput.setModel(dataModel);
        DefaultTableCellRenderer r = new DefaultTableCellRenderer();
        r.setHorizontalAlignment(SwingConstants.RIGHT);
        for(int i=0;i<7;i++){
            tableOutput.getColumnModel().getColumn(i).setCellRenderer(r);        
        }       

}//GEN-LAST:event_tableButtonActionPerformed
    private void outputClear(){
        CardLayout cl = (CardLayout)(cardPanel.getLayout());
        cl.show(cardPanel, "card0");
        domain.clear();
        drawPanelOutput.repaint();
        solveButton.setSelected(false);
        solveButton.setEnabled(true);
        
        tableButton.setEnabled(false);
        displacementButton.setEnabled(false);
        momentButton.setEnabled(false);
        shearButton.setEnabled(false);
        soilPressureButton.setEnabled(false);
        buttonGroup.clearSelection();
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new MainFrame().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton beamDialogOK;
    private javax.swing.JPanel beamPanel;
    private javax.swing.JPanel beamSecCardLayoutPanel;
    private javax.swing.JComboBox beamSecCombo;
    private javax.swing.JPanel beamSecRect;
    private javax.swing.JPanel beamSecTrpz;
    private javax.swing.JPanel beamSecUser;
    private javax.swing.ButtonGroup buttonGroup;
    private javax.swing.JPanel cardPanel;
    private javax.swing.JTextArea commentsField;
    private javax.swing.JToggleButton displacementButton;
    private gui.DrawPanelInput drawPanelInput;
    private gui.DrawPanelOutput drawPanelOutput;
    private javax.swing.JButton generalButton;
    private javax.swing.JButton generalCancel;
    private javax.swing.JButton generalOK;
    private javax.swing.JButton infoButton;
    private javax.swing.JPanel inputPanel;
    private javax.swing.JToolBar inputToolBar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel39;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel40;
    private javax.swing.JLabel jLabel41;
    private javax.swing.JLabel jLabel43;
    private javax.swing.JLabel jLabel44;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator14;
    private javax.swing.JSeparator jSeparator15;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JSeparator jSeparator5;
    private javax.swing.JSeparator jSeparator8;
    private javax.swing.JSeparator jSeparator9;
    private javax.swing.JButton loadButton;
    private javax.swing.JDialog loadDialog;
    private javax.swing.JButton loadDialogClose;
    private javax.swing.JComboBox loadElem;
    private javax.swing.JFormattedTextField loadElemPA;
    private javax.swing.JFormattedTextField loadElemPB;
    private javax.swing.JPanel loadElemPanel;
    private javax.swing.JButton loadElemSetButton;
    private javax.swing.JTextField loadElemText;
    private javax.swing.JComboBox loadNode;
    private javax.swing.JFormattedTextField loadNodeM;
    private javax.swing.JPanel loadNodePanel;
    private javax.swing.JButton loadNodeSetButton;
    private javax.swing.JTextField loadNodeText;
    private javax.swing.JFormattedTextField loadNodeV;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JFormattedTextField matBeamE;
    private javax.swing.JFormattedTextField matBeamGamma;
    private javax.swing.JFormattedTextField matBeamNu;
    private javax.swing.JPanel matBeamPanel;
    private javax.swing.JButton matButton;
    private javax.swing.JDialog matDialog;
    private javax.swing.JButton matDialogOK;
    private javax.swing.JFormattedTextField matSoilGamma;
    private javax.swing.JFormattedTextField matSoilKs;
    private javax.swing.JPanel matSoilPanel;
    private javax.swing.JButton matlDialogCancel;
    private javax.swing.JToggleButton momentButton;
    private javax.swing.JButton newFileButton;
    private javax.swing.JButton nodeAddButton;
    private javax.swing.JButton nodeButton;
    private javax.swing.JDialog nodeDialog;
    private javax.swing.JFormattedTextField nodeFromField;
    private javax.swing.JButton nodeGenButton;
    private javax.swing.JButton nodeOK;
    private javax.swing.JButton nodeRemButon;
    private javax.swing.JScrollPane nodeScrollPane;
    private javax.swing.JFormattedTextField nodeSegmentsField;
    private javax.swing.JTable nodeTable;
    private javax.swing.JFormattedTextField nodeToField;
    private javax.swing.JButton openFileButton;
    private javax.swing.JFileChooser openFileChooser;
    private javax.swing.JPanel outputPanel;
    private javax.swing.JToolBar outputToolBar;
    private javax.swing.JTextField projectField;
    private javax.swing.JDialog propsDialog;
    private javax.swing.JButton saveFileButton;
    private javax.swing.JFileChooser saveFileChooser;
    private javax.swing.JButton secButton;
    private javax.swing.JDialog secDialog;
    private javax.swing.JFormattedTextField secRectB;
    private javax.swing.JFormattedTextField secRectB0;
    private javax.swing.JFormattedTextField secRectH;
    private javax.swing.JFormattedTextField secRectH0;
    private javax.swing.JFormattedTextField secRectH1;
    private javax.swing.JFormattedTextField secTrpzB;
    private javax.swing.JFormattedTextField secTrpzB0;
    private javax.swing.JFormattedTextField secTrpzH;
    private javax.swing.JFormattedTextField secTrpzH0;
    private javax.swing.JFormattedTextField secTrpzH1;
    private javax.swing.JFormattedTextField secTrpzH2;
    private javax.swing.JFormattedTextField secUserA;
    private javax.swing.JFormattedTextField secUserB;
    private javax.swing.JFormattedTextField secUserH;
    private javax.swing.JFormattedTextField secUserI;
    private javax.swing.JToggleButton shearButton;
    private javax.swing.JButton soilDialogCancel2;
    private javax.swing.JToggleButton soilPressureButton;
    private javax.swing.JToggleButton solveButton;
    private javax.swing.JPanel statusBarPabel;
    private javax.swing.JLabel statusText;
    private javax.swing.JToggleButton tableButton;
    private javax.swing.JTable tableOutput;
    private javax.swing.JPanel tablePanel;
    private javax.swing.JScrollPane tableScrollPane;
    private javax.swing.JToolBar toolBar;
    private javax.swing.JTextField userField;
    // End of variables declaration//GEN-END:variables
}
