/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package misc;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowFocusListener;
import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToggleButton;

/**
 *
 * @author fotis
 */
public class ToggleButtonPopup extends JToggleButton {

    private JDialog popupWindow;

    public ToggleButtonPopup() {
        initPopup();
        ActionListener al = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (!popupWindow.isVisible()) {
                    showPopup();
                } else {
                    hidePopup();
                }
            }
        };
        this.addActionListener(al);
    }

     private void initPopup() {
        setText("Hide popup");
        popupWindow = new JDialog();
        popupWindow.setUndecorated(true);
        JPanel panel=new JPanel();
        popupWindow.setFocusable(true);
        WindowFocusListener focusListener=new WindowFocusListener() {
            public void windowGainedFocus(WindowEvent e) {
            }
            public void windowLostFocus(WindowEvent e) {
                hidePopup();
            }
        };
        popupWindow.addWindowFocusListener(focusListener);
        
        panel.setLayout(null);

        // set popup window visibility       

        int dx=200;
        int dy=200;
        panel.setPreferredSize(new Dimension(dx, dy));
        panel.setBorder(BorderFactory.createEtchedBorder());
        JLabel title=new JLabel("Title");
        title.setBounds(2,2,dx-4,20);
        title.setBorder(BorderFactory.createLineBorder(Color.BLUE));
        panel.add(title);
        
        // Key Listener
        popupWindow.addKeyListener(new KeyListener(){
            public void keyTyped(KeyEvent e) {
                if(e.getKeyCode()==KeyEvent.VK_CANCEL){
                    hidePopup();
                }
            }
            public void keyPressed(KeyEvent e) {
            }
            public void keyReleased(KeyEvent e) {
            }
        });
        
        // Cancel button
        JButton buttonCancel=new JButton(new ImageIcon("Images/button_cancel.png"));    
        buttonCancel.setBounds(dx-50,dy-26,22,22);
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                hidePopup();
            }
        });
        
         // OK button
        JButton buttonOK=new JButton(new ImageIcon("Images/button_ok.png"));
        buttonOK.setBounds(dx-26,dy-26,22,22);
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                hidePopup();
            }
        });

        panel.add(buttonCancel);
        panel.add(buttonOK);
        
        popupWindow.add(panel);
        popupWindow.pack();

    }

    private void showPopup() {
        // set popup window visibility
            
        // set location relative to button
        Point location=this.getLocationOnScreen();
        location.translate(this.getWidth(), 0);
        popupWindow.setLocation(location.x,location.y);

        // show the popup if not visible
        setText("Hide popup");
        popupWindow.setVisible(true);
        popupWindow.setAlwaysOnTop(true);
        popupWindow.requestFocus();
    }

    private void hidePopup() {
        setText("Show popup");
        popupWindow.setVisible(false);

    }

    public static void main(String args[]) {
        JFrame frame = new JFrame("Title Bar Text");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        ToggleButtonPopup a = new ToggleButtonPopup();
        frame.getContentPane().add(a);
        frame.pack();
        frame.setVisible(true);
    }
}
